#include <os.h>
#include <lauxlib.h>
#include <nspireio2.h>


static const unsigned goto0_addrs[] =  {0x0, 0x0, 0x0, 0x1006C158};		// ex_LUA_CALCALL1clon
#define goto0 SYSCALL_CUSTOM(goto0_addrs, int, int, int, char*, int, int, int, int)
static const unsigned goto1_addrs[] =  {0x0, 0x0, 0x0, 0x1006C210};		// ex_LUA_CALCALL1
#define goto1 SYSCALL_CUSTOM(goto1_addrs, int, int, int, char*, int, int, int, int)
// TAG2UTF16( *string tag, * o sera retourn un * sur le string utf16)
static const unsigned goto2_addrs[] =  {0x0, 0x0, 0x0, 0x1006BFE0};
#define goto2 SYSCALL_CUSTOM(goto2_addrs, void, char*, int, int, int)	// ex_TAG2UTF16_2

static const unsigned goto3_addrs[] =  {0x0, 0x0, 0x0, 0x10230BFC}; // refresh_docbrowser
#define goto3 SYSCALL_CUSTOM(goto3_addrs, void, int)

// Initialize console.
static nio_console csl;

int calculate(const char * calc, char ** p_result, int mode) {

	puts("0OK");
	char calc16[2 * (strlen(calc) + 1)];
	ascii2utf16(calc16, calc, sizeof(calc16));
	
	if      (mode == 0 && (goto0( 0x0, 0x0, calc16, 0x10000000, 0, 0, 0) == 0) )
	{	
		puts("1OK-C");
	}
	else if (mode == 1 && (goto1( 0x0, 0x0, calc16, 0x10000000, 0, 0, 0) == 0) )
	{
		puts("1OK-C");
	}
	else
	{
		puts("1FAIL");
		*p_result = malloc(0x10);
		strcpy(*p_result, "Syntax error");
		return 1;
	}

	char *tag =*((char**)0x10000000);
	goto2( tag, 0x10000004, 0x0, 0x0);
	
	puts("2OK");
	
	unsigned isresult =*((unsigned*)0x10000004);
	if (isresult != 0x0)
	{
        char *solve16 =*((char**)0x10000004);
        char solve[utf16_strlen(solve16) + 1];
        utf162ascii(solve, solve16, sizeof(solve)*2);
        *p_result = malloc(utf16_strlen(solve16) + 1);
        strcpy(*p_result, solve);
	}
	else
	{
        *p_result = malloc(0x10);
        strcpy(*p_result, "Done");
	}
	puts("3OK");
	
    return 0;
}

/*
static int launch() {

   const char * title = "nCAS";
   const char * msg = ">";
   char * defaultvalue = "0";
   char * calc;
   
   while(1)
   {
       unsigned len = msg_user_input(title, msg, defaultvalue, &calc);
       *(calc+len)=0x0;
       puts("--");
       printf("%s (%d)\n", calc, len);
       puts("-");
       calculate(calc);
       if(isKeyPressed(KEY_NSPIRE_ESC)) break;
   }
	
    return 0;
}
//*/

//*
static int launch() {

	char text[0x1000];
	if(has_colors) lcd_ingray();
	wait_no_key_pressed();
	
	// 53 columns, 30 rows. 0px offset for x/y. Background color 15 (white), foreground color 0 (black)
	nio_InitConsole(&csl,53,30,0,0,15,0);
	nio_DrawConsole(&csl);
	nio_printf(&csl,"nCalc v0.00003\n>");
	
	puts("init");
	while( !isKeyPressed(KEY_NSPIRE_ESC) )
	{
		puts("----");
		// If no text was entered, exit
		if(nio_GetStr(&csl,text))
		{
			// Write calc output
			puts("--");
			char * correct;
			int rok = calculate(text, &correct, 0);
			nio_printf(&csl, correct);
			nio_printf(&csl,"\n");
			puts("--");
			
			if (!rok)
			{
				char *result;
				calculate(correct, &result, 1);
				nio_printf(&csl, result);
				nio_printf(&csl,"\n");	
				free(result);				
				puts("--");
			}
			
			free(correct);
		}
		nio_printf(&csl,">");
	}
	
	puts("end");
	nio_CleanUp(&csl);
	if(has_colors) lcd_incolor();
	
	return 0;
}
//*/

//*
static int exittns() {
	puts("Exit");
	goto3(0x1B5B);
	asm("LDR    PC, =0x100EADC4 ");	
	puts("Fatal Failure!");
	return 0;
}
//*/
static const luaL_reg lualib[] = {
	{"launch", launch},
	{"exittns", exittns},
	{NULL, NULL}
};

int main(void) {
	// can also work quite well without the lua ext
	lua_State *L = nl_lua_getstate();
	if (!L) return 0; // not being called as Lua module
	nl_relocdata((unsigned*)lualib, (sizeof(lualib) / sizeof(unsigned*)) - 2);
	luaL_register(L, "nCAS", lualib);
	return 0;
}
